clc;
clear all;
close all;

im = imread('folha.png');
im = im(:,:,1);
[linhas,colunas] = size(im);

% Adjacncia-4
pontos = [-1 0; 0 +1; +1 0; 0 -1];
N = 4;
im1 = im;

for y=1:linhas
    for x=1:colunas
        S = 0;
        for k=1:N
            py = y + pontos(k,1);
            px = x + pontos(k,2);
            if(py > 0 && py <= linhas && px > 0 && px <= colunas)
                if(im(py,px) > 0)
                    S = S + 1;
                end
            end
        end
        
        if (S == N)
            im1(y,x) = 0;
        end
    end
end

imshow(im1);

% =====================================================================
% Distncia Euclidiana

[py,px] = find(im1 > 0);
N = length(py);
distancias = zeros(linhas,colunas);

for y=1:linhas
    for x=1:colunas
        D = Inf;
        for k=1:N
            D1 = sqrt((y-py(k))^2 + (x-px(k))^2);
            if (D1 < D)
                D = D1;
            end            
        end
        distancias(y,x) = D;
    end
end

figure;
imagesc(distancias);
colorbar;
